import java.lang.Object.*;
import java.util.*;
import java.io.*;

public class  MXBtokenizer {
	TokenList tklist = new TokenList();
	public MXBtokenizer() {}
	public TokenList Tokenize (String Command) {
		int flag = 0;
		String word = new String();
		String nword = new String();
		StringTokenizer tok = new StringTokenizer(Command, ":/[]><= \"\t\n\r\f", true);
		while (tok.hasMoreTokens()) {
			Token tkn = new Token();
			flag = 0;
			word = tok.nextToken();
			if (word.equals(":")) {
				nword = tok.nextToken();
				word = word + nword;
				tkn.SetValue(word);
				tkn.SetType("Separator");
				tklist.tokenlist.addFirst(tkn);
				continue;
			}
			if (word.equals("[") || word.equals("]") || word.equals("/")) {
				tkn.SetType("Separator");
				flag = 1;
			}
			nword = word.toUpperCase();
			if (nword.equals("CREATE") || nword.equals("INSERT") || nword.equals("DROP") || nword.equals("LIST")) {
				tkn.SetType("Keyword");
				flag = 1;
			}
			if (nword.equals("SELF") || nword.equals("CHILD") || nword.equals("PARENT") || nword.equals("FOLLOWING-SIBLING") || nword.equals("PRECEDING-SIBLING") || nword.equals("ATTRIBUTE")) {
				tkn.SetType("Axis");
				flag = 1;
			}
			int len = word.length();
			if(len>2)
				if ((word.substring(len-2, len)).equals("()")) {
					tkn.SetType("Function");
					flag = 1;
				}
			if(word.equals("=")) {
				tkn.SetType("Operator");
				flag = 1;
			}
			if(word.equals("\"")) {
				nword = tok.nextToken();
				while(!nword.equals("\"")){
					word = word + nword;
					nword = tok.nextToken();
				}
				word = word + "\"";
				tkn.SetType("Other");
				tkn.SetValue(word);
				tklist.tokenlist.addFirst(tkn);
				continue;
			}
			if (word.equals("<") || word.equals(">")) {
				nword = tok.nextToken();
				if (nword.equals(">") || nword.equals("=") || nword.equals("<")) {
					word = word + nword;
					tkn.SetType("Operator"); 
					tkn.SetValue(word);
					tklist.tokenlist.addFirst(tkn);
					continue;
				}
				else {
					tkn.SetValue(word);
					tkn.SetType("Operator");
					tklist.tokenlist.addFirst(tkn);
      					Token tkn1 = new Token();
					if(nword.equals("\"")) {
        		                        word = tok.nextToken();
                		                while(!word.equals("\"")){
                        		                nword = nword + word;
							word = tok.nextToken();
                                		}
               			                nword = nword + "\"";
                		                tkn1.SetType("Other");
                        		        tkn1.SetValue(nword);
                        		        tklist.tokenlist.addFirst(tkn1);
                             			continue;
                        		}
					else {
						tkn1.SetValue(nword);
						tkn1.SetType("Other");
						tklist.tokenlist.addFirst(tkn1);
						continue;
					}
				}
			}
			if (flag == 0)
				tkn.SetType("Other");
			tkn.SetValue(word);
			tklist.tokenlist.addFirst(tkn);
		}
		return tklist;
//		for(Iterator i = tklist.value.iterator(); i.hasNext();)
//			System.out.println(i.next());
//		System.out.println();
//		for(Iterator i = tklist.type.iterator(); i.hasNext();)
//			System.out.println(i.next());
	}
}

